
/* Programmiert von Hans-Juergen Herbert
				Schneppenhaeuser Strasse 10
				6108 Weiterstadt
				West Germany
				*/

#include <heport.h>
#include <helq.h>

/* ---------------------------------------------------------- */
FUNCT int asctobool(	// String, numeric, decimale to unsigned charachter
const char **plst,		// There is the bool value as string, f.e. "0", "1"
bool		*adr )		// save binary to this location
{
const char *lst ;

lst = *plst ;

skipwhite( lst );

if ( *lst == '0' )
	{
	*adr = false ;
	++lst ;
	*plst = lst ;
	return 0 ;		// no error
	}
if ( *lst == '1' )
	{
	*adr = true ;
	++lst ;
	*plst = lst ;
	return 0 ;		// no error
	}
*plst = lst ;
return 1 ;			// Error - bad bool string, not 0/1
}		 /* end asctobool() */
