
/* Programmiert von Hans-Juergen Herbert
				Frankfurter Str. 28 B
				64331 Weiterstadt
				Germany
				*/

#include <heport.h>
#include <helq.h>


/* ---------------------------------------------------------- */
// convert upto 4 hex characters (0-9, A-F or a-f) into a uword
// return error if bad character inside found
// Update Pointer to string, so end of hex string character
// might be examined.
FUNCT int asctohw(		// HEX represented string to binary
char const	**plst,		// where to find the string
uword	*adr )			// where to store the result
{
int knz ;			/* Kennung : Ziffern kamen */
register uint	zzz ;
unsigned int zif ;
char const *lst ;


lst = *plst ;
zzz = 0 ;
knz = 0 ;
skipwhite( lst );

if ( lst[0] == '0' && ( lst[1] == 'X' || lst[1] == 'x' ) ) lst += 2 ;

for (;;)
	{
	if ( *lst >= '0' && *lst < '9'+1 )
		{
		zif = *lst - '0' ;
		}
	else if ( *lst >= 'A' && *lst <='F' )
		{
		zif = *lst + ( -'A' + 0x0a ) ;
		}
	else if ( *lst >= 'a' && *lst <= 'f' )
		{
		zif = *lst + ( -'a' + 0x0a ) ;
		}
	else break ;		/* Keine Hex-Ziffern mehr */
	knz = 1 ;
	if ( zzz <= 0xfff )
		{
		zzz = ( zzz << 4 ) + zif ;
		}
	else
		{
		return 2 ;
		}
	++lst ;
	}

skipwhite( lst );

if ( knz )
	{	/* Zahl war gegeben - o.k. */
	*adr = zzz ;
	*plst = lst ;
	return 0 ;	/* kein Fehler */
	}
else
	{
	*plst = lst ;
	return 1 ;	/* Fehler - keine Ziffer */
	}
}		/* end asctohw() */
