
/* Programmiert von Hans-Juergen Herbert
				Frankfurter Strae 28
				D-64331 Weiterstadt
				Germany
				*/

#include <heport.h>
#include <helq.h>

/* ---------------------------------------------------------- */
FUNCT int asctosc(		 // String to signed word
char const **ppc ,			   // There is the string, f.e. "-128", "124"
schar	   *adr )			 // save binary to this location
{
uchar negativ ;
const char *pc ;
int rv ;
uchar uc ;

pc = *ppc ;
negativ = 0 ;

skipwhite( pc );
if ( *pc == '-' )
	{				// negative number
	negativ = 1 ;
	++pc ;
	}
*ppc = pc ;

rv = asctouc( ppc, &uc );
if ( rv != 0 ) return rv ;
if ( negativ )
	{
	if ( uc > 128 ) return 4 ;
	*adr = -uc ;
	}
else
	{
	if ( uc > 127 ) return 4 ;
	*adr = uc ;
	}
return 0 ;		// no error detected
}		 /* end asctosw() */

