
/* Programmiert von Hans-Juergen Herbert
				Frankfurter Strae 28
				D-64331 Weiterstadt
				Germany
				*/

#include <heport.h>
#include <helq.h>

/* ---------------------------------------------------------- */
FUNCT int asctosw(		 // String to signed word
char const **ppc ,			   // There is the string, f.e. "-12", "32765"
sword	   *adr )			 // save binary to this location
{
uchar negativ ;
const char *pc ;
int rv ;
uword uw ;

pc = *ppc ;
negativ = 0 ;

skipwhite( pc );
if ( *pc == '-' )
	{				// negative number
	negativ = 1 ;
	++pc ;
	}
*ppc = pc ;

rv = asctouw( ppc, &uw );
if ( rv != 0 ) return rv ;
if ( negativ )
	{
	if ( uw > 32768 ) return 4 ;
	*adr = -uw ;
	}
else
	{
	if ( uw > 32767 ) return 4 ;
	*adr = uw ;
	}
return 0 ;		// no error detected
}		 /* end asctosw() */

