
/* Programmiert von Hans-Juergen Herbert
				Frankfurter Str 28b
				6108 Weiterstadt
				West Germany
				*/

#include <heport.h>
#include <helq.h>

/* ---------------------------------------------------------- */
FUNCT int asctouc(		 // String, numeric, decimale to unsigned charachter
const char **ppc ,		   // There is the string, f.e. "24", "255"
uchar	 *adr )		   // save binary to this location
{
uchar			knz ;		 // Flag: digits are detected
register uchar	  zzz ;
const char *pc ;
uchar uc ;

pc = *ppc ;
zzz = 0 ;
knz = 0 ;

skipwhite( pc );

while ( ( uc = (uchar)(*pc -'0') ) < 10 ) 		// '0' ... '9'
	{
	knz = 1 ;
	if ( zzz <= 25 )
		{
		if ( zzz == 25 && uc > 5 )	// maximum is 255
			{
			*ppc = pc ;
			return 2 ;		// number too big
			}
		zzz *= 10 ;
		zzz += uc ;
		}
	else
		{
		*ppc = pc ;
		return 2 ;		// number too big
		}
	++pc ;
	}

*ppc = pc ;

/* numbers are divided by follow characters */
if ( knz )
	{	 /* Zahl war gegeben - o.k. */
	*adr = zzz ;
	return 0 ;	  /* kein Fehler */
	}
else
	{
	return 1 ;	  /* Fehler - keine Ziffer */
	}
}		 /* end asctoc() */

