#include <heport.h>		// special type names, uword, sword ...
#include <helq.h>		// uprintf
#include <tshar.h>
#include <tsinout.h>		// prototypes for all functions defined here


// read a line of text
FUNCT char in_line( void )
{
uchar i ;
char c ;
char *p ;						// Save the string here
uchar n ;						// Maximum space

p = in_charbuffer[tshar_task_no] ; 			// Save the string here
n = NIN_CHARBUFFER ;			// Maximum space
i = 0 ;
for(;;)
	{
	c = in_char();
	if ( c == 0x20 ||			// Blank
		 c == ',' ||			// Blank
		 c == 0x0d )			// Enter
		{
		p[i] = 0 ;
		return 0 ;
		}
	if ( c < ' ' )
		{
		if ( c == 0x7f || c == 0x08 )		// delete or backspace: remove one character from end
			{
			if ( i > 0 )
				{
				--i ;
				out_puts( "\b \b" );
				}
			}
		if ( c == 'X'-'@' || c == 'U'-'@' )		// Control X - or control U : Clear line
			{
			while ( i > 0 )
				{
				--i ;
				out_puts( "\b \b" );
				}
			}
		if ( c == 0x1b ) return 1 ; // Abort
		}
	else
		{
		if ( i < n-1 )
			{
			p[i++] = c ;
			out_char(c);			// Echo the stored character
			}
		}
	}
}

