#include <heport.h>		// special type names, uword, sword ...
#include <helq.h>		// uprintf
#include <tshar.h>
#include <tsinout.h>		// prototypes for all functions defined here



#if 0

FUNCT void out_uint32( ulong h)	// Output a decimale number 0 .. 4294967295
{
ulong r ;
ulong z ;
uchar i ;
bool must ;

r = h ;
for ( i = 10 ; i ; )
	{
	--i ;
	z = r ;
	r = r / 10 ;
	in_charbuffer[tshar_task_no][i] = z - r * 10 ;
	}
must = false ;
for ( i = 0 ; i < 10 ; ++i )
	{
	if ( i == 9 || in_charbuffer[tshar_task_no][i] != 0 || must )
		{
		must = true ;
		out_char( in_charbuffer[tshar_task_no][i] + '0' );
		}
	}
}

#else


struct snums {
ulong v ;
uchar k ;
uchar d ;
	} ;

#define NNUMS (4*9+3)		// 9 decimale digits with 4 bits, one with 3 bits
struct snums vnums[NNUMS] = {
	{ 4000000000UL, 0, 4 } ,		// 0
	{ 2000000000UL, 0, 2 } ,
	{ 1000000000UL, 0, 1 } ,
	{  800000000UL, 1, 8 } ,
	{  400000000UL, 1, 4 } ,
	{  200000000UL, 1, 2 } ,		// 5
	{  100000000UL, 1, 1 } ,
	{   80000000UL, 2, 8 } ,
	{   40000000UL, 2, 4 } ,
	{   20000000UL, 2, 2 } ,
	{   10000000UL, 2, 1 } ,		// 10
	{    8000000UL, 3, 8 } ,
	{    4000000UL, 3, 4 } ,
	{    2000000UL, 3, 2 } ,
	{    1000000UL, 3, 1 } ,		// 14
	{     800000UL, 4, 8 } ,		// 15
	{     400000UL, 4, 4 } ,		// 16
	{     200000UL, 4, 2 } ,
	{     100000UL, 4, 1 } ,
	{      80000UL, 5, 8 } ,
	{      40000UL, 5, 4 } ,		// 20
	{      20000UL, 5, 2 } ,
	{      10000UL, 5, 1 } ,
	{       8000UL, 6, 8 } ,
	{       4000UL, 6, 4 } ,
	{       2000UL, 6, 2 } ,		// 25
	{       1000UL, 6, 1 } ,
	{        800UL, 7, 8 } ,
	{        400UL, 7, 4 } ,
	{        200UL, 7, 2 } ,		// 29
	{        100UL, 7, 1 } ,		// 30
	{         80UL, 8, 8 } ,
	{         40UL, 8, 4 } ,
	{         20UL, 8, 2 } ,
	{         10UL, 8, 1 } ,
	{          8UL, 9, 8 } ,		// 35
	{          4UL, 9, 4 } ,
	{          2UL, 9, 2 } ,
	{          1UL, 9, 1 } } ;		// 38

// See also
// ascfrul.cpp
FUNCT void out_uint32( ulong h)	// Output a decimale number 0 .. 4294967295
{
char dig[10] ;
uchar i ;
uchar s ;		// Start Digit



for ( i = 0 ; i < 10 ; ++i )
	{
	dig[i] = '0' ;	// i = 0 ... 9 : 10 digits
	}
// optimize for small numbers
if ( h < 80000L )
	{
	if ( h < 400L ) 
		{ 		// 8 bit numbers
		i = 29 ; 
		s = 7 ; 
		}
	else 
		{ 		// 16 bit numbers	
		i = 16 ; 
		s = 4 ; 
		}
	}
else 
	{ 	// Big numbers
	i = 0 ; 
	s = 0 ; 
	}

for ( i = i ; i < NNUMS ; ++i )
	{
	if ( h >= vnums[i].v )
		{
		h -=  vnums[i].v ;
		dig[vnums[i].k] += vnums[i].d ;
		}
	}
// Skip 0 to 9 leading zeroes place(10^10 to 10^1)
for ( i = s ; i < 9 ; ++i )
	{
	if ( dig[i] != '0' ) break ;
	}

// Display rest of the ASCII converted number
for ( i = i ; i < 10 ; ++i )
	{
	out_char( dig[i] );
	}
}

#endif
