// /home/cc/include/tsser.h

#ifdef AVR
#include <avr/io.h>
#include <avr/pgmspace.h>
#endif


// The device depend base functions.
// User program call out_char() in_char() and in_ckheck() instead, 
// The timesharing tshar.cpp decides then if the output goes to 
// serial1, serial2, display, LCD or whereelse

extern void tsseropen( void );		// Prepare the interface
extern void tsserclose( void );		// Switch the interface off
extern uchar tsser_in_char( void ); // wait until a character is typed in,reutn it.
extern void tsser_out_char( const uchar c );		// Output a character
extern bool tsser_in_check( void );	// check if a character is typed in
