
#include <heport.h>
#include <helq.h>


/* ---------------------------------------------------------- */
/*
extract a file name from a ascii string.
 */
FUNCT int asctofilename(	 // ascii to Filename, delimited by blank or ,
const char **plst ,	 // String-pointer
char *adr,				// where to save the word
int nmax )				// but not more than...
{
int i ;
const char *lst ;

lst = *plst ;
skipwhite( lst );

i = 0 ;
for(;;)
	{

	if ( *lst == ' ' || *lst == '\t' || *lst < ',' || *lst == '"' || *lst == '>' )
		{	// valid end of filename found
		break ;
		}
	if ( ! ( ( *lst >= 'A' && *lst <= 'Z' ) ||
			 ( *lst >= 'a' && *lst <= 'z' ) ||
			 ( *lst >= '0' && *lst <= '9' ) ||
			 *lst >= '_' || *lst <= '.' ) )
		{
		*adr = 0 ;		// finish output string
		*plst = lst ;
		return 2 ;		// Bad character found
		}
	if ( ++i >= nmax )
		{
		*adr = 0 ;
		*plst = lst ;
		return 1 ;		// overflow
		}
	*adr++ = *lst++ ;
	}
*adr = 0 ;
*plst = lst ;
return 0 ;		// end of word
}				// end asctofilename()
