
/* Programmiert von Hans-Juergen Herbert
				Schneppenhaeuser Strasse 10
				6108 Weiterstadt
				West Germany
				*/

#include <heport.h>
#include <helq.h>


/* ---------------------------------------------------------- */
// convert exactlty 4 hex characters (0-9, A-F or a-f) into a uchar
// return error if bad character inside found
// Update Pointer to string, so end of hex string character
// might be examined.
FUNCT int asctohx4(		 // HEX represented string to binary
const char **plst ,			  // where to find the string
uword *adr )		  // where to store the result
{
uword  zb ;
uchar zif ;
int i ;
const char *lst ;

lst = *plst ;
zb = 0 ;

if ( lst[0] == '0' && ( lst[1] == 'X' || lst[1] == 'x' ) ) lst += 2 ;

for ( i = 1 ; i <= 4 ; ++ i )
	{
	if ( *lst >= '0' && *lst < '9'+1 )
		{
		zif = *lst - '0' ;
		}
	else if ( *lst >= 'A' && *lst <='F' )
		{
		zif = *lst + ( -'A' + 0x0a ) ;
		}
	else if ( *lst >= 'a' && *lst <= 'f' )
		{
		zif = *lst + ( -'a' + 0x0a ) ;
		}
	else
		{
		*plst = lst ;
		return i ;		// bad hex character 1
		}
	++lst ;
	zb <<= 4 ;			// widht of a hex character
	zb |= zif ;			// that new character
	}
*adr = zb ;
*plst = lst ;
return 0 ;

}		/* end asctohx2() */
