/* Programmiert von Hans-Juergen Herbert
		Schneppenhaeuser Strasse 10
		6108 Weiterstadt
		West Germany
		*/

#include <stdio.h>
#include <heport.h>
#include <helq.h>

/* ---------------------------------------------------------- */
/*
DD asctol
DD ASCII (String) in long-Zahl umwandeln. ASCII ist Dezimalzahl.
DD 1.P: char *st			Da steht z.B. "-1200000" oder "395876"
DD 2.P: long *perg			Dahin wird das Ergebnis gespeichert.
DD int rv 0 wenn alles o.k.
 */
FUNCT int asctosl( /* String to signed long */
const char **plst ,
slong	*adr )
{
int		knz ;	/* Kennung : Ziffern kamen */
register long	zzz ;
bool sign = false ;
const char *lst ;

lst = *plst ;
zzz = 0 ;
knz = 0 ;

skipwhite( lst );

if ( *lst == '-' )
	{
	++lst ;
	sign = true ;
	}
while ( *lst >= '0' && *lst < '9'+1 )
	{
	knz = 1 ;
	if ( zzz <= 214748364L )	/* 0x7fffffff / 10 */
		{
		zzz = zzz * 10 + *lst - '0' ;
		}
	else
		{
		*plst = lst ;
		return 2 ;
		}
	++lst ;
	}

*plst = lst ;
if ( knz )
	{		/* Zahl war gegeben - o.k. */
	if ( sign ) zzz = -zzz ;
	*adr = zzz ;
	return 0 ;		/* kein Fehler */
	}
else
	{
	return 1 ;		/* Fehler - keine Ziffer */
	}
}			/* end asctosl() */
