
#include <heport.h>
#include <helq.h>


/* ---------------------------------------------------------- */
/*
ASCII to Token string, see also loctotok : locale to string
					   see also asctostr : Ascii To String (not only A-Z 0-9)
 */
FUNCT int asctotok(		// get token, either numeric or alphabetic
const char **ppc ,		// Pointer to String-pointer, will be modified
char *adr,				// where to save string
int nmax )				// but not more than...
{
int i ;
const char *pc ;

pc = *ppc ;				// Get string Pointer from Argument, Pointer to Pointer
skipwhite( pc );

i = 0 ;
if ( *pc >= '0' && *pc < '9'+1 )
	{	// a numerical token starts
	while ( *pc >= '0' && *pc < '9'+1 )
		{
		if ( ++i >= nmax )
			{
			*adr = 0 ;
			*ppc = pc ;		// save pointer to caller
			return 1 ;	// overflow
			}
		*adr++ = *pc++ ;
		}
	*adr = 0 ;
	*ppc = pc ;		// save pointer to caller
	return 0 ;		// end of numeric
	}
if ( cisalpha(*pc) )
	{		// a alphabetical token starts
	while ( ( *pc >= '0' && *pc < '9'+1 ) || cisalpha( *pc ) )
		{
		if ( ++i >= nmax )
			{
			*adr = 0 ;
			*ppc = pc ;		// save pointer to caller
			return 2 ;	// overflow
			}
		*adr++ = *pc++ ;
		}
	*adr = 0 ;
	*ppc = pc ;		// save pointer to caller
	return 0 ;		// end of alpha numeric
	}
*adr = 0 ;
*ppc = pc ;		// save pointer to caller
return 3 ;
}		/* end asctotok() */
