
#include <heport.h>
#include <helq.h>


/* ---------------------------------------------------------- */
/*
ASCII to word string
 */
FUNCT int asctowrd(		// ascii to word, delimited by	' '	 ','  TAB  NEWLINE	0
const char **ppc ,		// String-pointer
char *adr,				// where to save the word
int nmax )				// but not more than...
{
int i ;
const char *pc ;


pc = *ppc ;				// get pointer

skipwhite( pc );

i = 0 ;
while ( ! ( *pc == ' ' ||
			*pc == 0 ||
			*pc == 0x03 ||		// AK line end
			*pc == '\n' ||
			*pc == '\t' ||
			*pc == ';' ||
			*pc == ',' ) )
	{	// more characters of string
	if ( ++i >= nmax )
		{
		*adr = 0 ;
		*ppc = pc ;		// restore pointer to caller
		return 1 ;	// overflow
		}
	*adr++ = *pc++ ;
	}
*adr = 0 ;
*ppc = pc ;		// restore pointer to caller
if ( i == 0 )	// no byte copied
	{
	return 3 ;
	}
return 0 ;		// end of word
}		/* end asctowrd() */
