#include <heport.h>
#include <tsinout.h>
#ifdef AVR

// FUNCT void out_puts_P( const prog_char * p )
// #define PGM_P const prog_char *
// Output / send a string out of program memory

// _Z10out_puts_PPKc
asm(".text\n");
asm("    .global _Z10out_puts_PPKc\n");
asm("_Z10out_puts_PPKc:\n");
asm("    MOVW    R30,R24          ; Copy register pair (Pointer) to Z\n" );
asm("out_puts_P_1:\n" );
asm("    LPM     R24,Z+           ; Load a byte from Program Memory\n" );
asm("    TST     R24              ; Check if 0\n" );
asm("    BRNE    out_puts_P_2    ; else ...\n" );
asm("    RET                        \n");
asm("out_puts_P_2:\n" );
asm("    PUSH    R30              ; Push register on stack\n");
asm("    PUSH    R31              ; Push register on stack\n");
asm("    CPI     R24,0x0a         ; Check if is Newline character\n" );
asm("    BRNE    out_puts_P_3     ; else output the character\n" );
asm("    RCALL	 _Z6out_nlv       ; Output CR-LF Combo or whatever\n" );
asm("    RJMP    out_puts_P_4      \n");
asm("out_puts_P_3:\n"                                                 );
asm("    RCALL	 _Z8out_charh     ; Output CR-LF Combo or whatever\n" );
asm("out_puts_P_4:\n" );
asm("    POP     R31              ; function out_char() destroys Z  \n");
asm("    POP     R30              ; restore counter  \n");
asm("    RJMP    out_puts_P_1      \n");



#else
// TC, MDOS40, LINUX, ...
FUNCT void out_puts( const char *p )	// Output / send a string
{
char c ;

while ( ( c = *p++ ) != 0 )
	{
	if ( c == '\n' )
		{
		out_nl();
		}
	else
		{
		out_char( c );
		}
	}
return ;
}
#endif


FUNCT void out_putsv( const char *p )	// Output / send a string
{
char c ;

while ( ( c = *p++ ) != 0 )
	{
	if ( c == '\n' )
		{
		out_nl();
		}
	else
		{
		out_char( c );
		}
	}
return ;
}

